<?php
function mylnk_find_link($entrada)
// Find all links in a especific post or page
// return array [link, position]
{
	$entrada = mylnk_elimina_espacios($entrada);
	$tamano = 0;
	$len_anterior = 0;
	$link_pos[] = 0;
	$num_link = 0;
	do
	{
		$pos_inicial = strpos($entrada,"<a href");
		if ($pos_inicial !== false) 
		{
				$aguja = ">";
				$pos_final = strpos($entrada,$aguja,$pos_inicial); 
				$len_anterior = $tamano;
				$tamano = $pos_final - $pos_inicial + 1;
				if ($pos_final !== false)
				{
					$mylnk_link = substr($entrada,$pos_inicial, $tamano );
					if ($num_link == 0) {
						$link_pos[$num_link] = $pos_inicial;
					} else {
						$link_pos[$num_link] = $pos_inicial + $link_pos[$num_link - 1] + $len_anterior;
					}
					$link_encontrado[] = [ $mylnk_link, $link_pos[$num_link] ];
					$entrada = substr($entrada,$pos_inicial + $tamano);
					$num_link++;
				}
		}
		else
		{	
			$link_encontrado[] = [false,false];
			$entrada = "";
		}
	} while (strlen($entrada)>0);
	return $link_encontrado;
}

function mylnk_del_link(){
	$post_id = absint($_POST['post_id']);
	$current_url = esc_url_raw($_POST['current_url']);
	$type = esc_url_raw($_POST['type']);
	if (function_exists ('check_admin_referer'))
		check_admin_referer('mylnk_'.$post_id);

	if ($type ="page") {
		$mylnk_post = get_page($post_id);
		$mylnk_capability = 'edit_pages';
	}		
	if ($type ="post") {
		$mylnk_post = get_post($post_id);
		$mylnk_capability = 'edit_posts';
	}
	if (!empty($_POST['mylnk_datos'])) { 
		$data = $_POST['mylnk_datos'];
		$mylnk_text = $mylnk_post->post_content;
		foreach ($data as $lista=>$link) {
			$mylnk_link = html_entity_decode($link);
			$datos = explode(",", $lista);
			$count = $datos[0];
			$pos = $datos[1];
		// Elimina el link
			$reemplaza = str_pad("", strlen(html_entity_decode($mylnk_link))+0, " ");
			$mylnk_text = substr_replace($mylnk_text, $reemplaza, $pos, strlen($reemplaza));	
		}
		$mylnk_post->post_content = $mylnk_text;
		// Reemplaza en el objeto el nuevo post
			$mylnk_post_array = get_object_vars($mylnk_post);
		// Graba el nuevo post
			if (current_user_can($mylnk_capability)){
				wp_update_post( $mylnk_post_array );
				echo "Se actualizo";
			}
	}
	wp_redirect( $current_url );
	exit;
}

function mylnk_bootstrap_css() {
// Bootstrap CSS
	wp_enqueue_style('bootstrap_css',
					MYLNK_P_RUTA.'/includes/css/bootstrap.min.css',
					array(), 
  					'4.3.1'
  					); 
}

function mylnk_bootstrap_js() { 
// Bootstrap JS and popper
	wp_enqueue_script( 'bootstrap_js', 
  					MYLNK_P_RUTA.'/includes/js/bootstrap.min.js', 
  					array('jquery'), 
  					'4.3.1', 
  					true);
}


function mylnk_funciones_js() { 
// Funciones Javascript
	wp_enqueue_script( 'funciones_js', 
  					MYLNK_P_RUTA.'/includes/js/mylnk_funciones.js');
}

function mylnk_elimina_espacios($cadena){
// Delete double space in a string
// and delete a space between "<" and "a"
	$cadena = preg_replace('/\s+/', ' ', $cadena);
	$cadena = preg_replace('/< a/', '<a', $cadena);
	return $cadena;
}
function mylnk_toactive()
{
// To future uses	
    add_option('mylnk_key_license','community','','yes');
}
function mylnk_todeactive()
{
    delete_option('mylnk_key_license');
}
?>